JUCE: Image::BitmapData Class Reference

JUCE

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Public Attributes | List of all members
Image::BitmapData Class Referencefinal
juce_graphics » images

Retrieves a section of an image as raw pixel data, so it can be read or written to. More...

`#include <juce_Image.h>`

## Classes
class | BitmapDataReleaser
| Used internally by custom image types to manage pixel data lifetime. More...

## Public Types
enum | ReadWriteMode { readOnly , writeOnly , readWrite }

## Public Member Functions
| BitmapData (Image &image, int x, int y, int w, int h, ReadWriteMode mode)
| BitmapData (const Image &image, int x, int y, int w, int h)
| BitmapData (const Image &image, ReadWriteMode mode)
| ~BitmapData ()
uint8 * | getLinePointer (int y) const noexcept
| Returns a pointer to the start of a line in the image.
uint8 * | getPixelPointer (int x, int y) const noexcept
| Returns a pointer to a pixel in the image.
Colour | getPixelColour (int x, int y) const noexcept
| Returns the colour of a given pixel.
void | setPixelColour (int x, int y, Colour colour) const noexcept
| Sets the colour of a given pixel.
Rectangle< int > | getBounds () const noexcept
| Returns the size of the bitmap.

## Public Attributes
uint8 * | data
| The raw pixel data, packed according to the image's pixel format.
size_t | size
| The number of valid/allocated bytes after data.
PixelFormat | pixelFormat
| The format of the data.
int | lineStride
| The number of bytes between each line.
int | pixelStride
| The number of bytes between each pixel.
int | width
int | height
std::unique_ptr< BitmapDataReleaser > | dataReleaser

## Detailed Description

Retrieves a section of an image as raw pixel data, so it can be read or written to.

You should only use this class as a last resort - messing about with the internals of an image is only recommended for people who really know what they're doing!

A BitmapData object should be used as a temporary, stack-based object. Don't keep one hanging around while the image is being used elsewhere.

Depending on the way the image class is implemented, this may create a temporary buffer which is copied back to the image when the object is deleted, or it may just get a pointer directly into the image's raw data.

You can use the stride and data values in this class directly, but don't alter them! The actual format of the pixel data depends on the image's format - see Image::getFormat(), and the PixelRGB, PixelARGB and PixelAlpha classes for more info.

## Member Enumeration Documentation

## ◆ ReadWriteMode

enum Image::BitmapData::ReadWriteMode

Enumerator
readOnly |
writeOnly |
readWrite |

## Constructor & Destructor Documentation

## ◆ BitmapData() [1/3]

Image::BitmapData::BitmapData | ( | Image & | image,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h,
|  | ReadWriteMode | mode
| ) |  |

## ◆ BitmapData() [2/3]

Image::BitmapData::BitmapData | ( | const Image & | image,
|  | int | x,
|  | int | y,
|  | int | w,
|  | int | h
| ) |  |

## ◆ BitmapData() [3/3]

Image::BitmapData::BitmapData | ( | const Image & | image,
|  | ReadWriteMode | mode
| ) |  |

## ◆ ~BitmapData()

Image::BitmapData::~BitmapData | ( |  | ) |

## Member Function Documentation

## ◆ getLinePointer()

uint8 * Image::BitmapData::getLinePointer | ( | int | y | ) | const
| noexcept

Returns a pointer to the start of a line in the image.

The coordinate you provide here isn't checked, so it's the caller's responsibility to make sure it's not out-of-range.

## ◆ getPixelPointer()

uint8 * Image::BitmapData::getPixelPointer | ( | int | x,
|  | int | y
| ) |  | const
| noexcept

Returns a pointer to a pixel in the image.

The coordinates you give here are not checked, so it's the caller's responsibility to make sure they're not out-of-range.

## ◆ getPixelColour()

Colour Image::BitmapData::getPixelColour | ( | int | x,
|  | int | y
| ) |  | const
| noexcept

Returns the colour of a given pixel.

For performance reasons, this won't do any bounds-checking on the coordinates, so it's the caller's responsibility to make sure they're within the image's size.

## ◆ setPixelColour()

void Image::BitmapData::setPixelColour | ( | int | x,
|  | int | y,
|  | Colour | colour
| ) |  | const
| noexcept

Sets the colour of a given pixel.

For performance reasons, this won't do any bounds-checking on the coordinates, so it's the caller's responsibility to make sure they're within the image's size.

## ◆ getBounds()

Rectangle< int > Image::BitmapData::getBounds | ( |  | ) | const
| noexcept

Returns the size of the bitmap.

## Member Data Documentation

## ◆ data

uint8* Image::BitmapData::data

The raw pixel data, packed according to the image's pixel format.

## ◆ size

size_t Image::BitmapData::size

The number of valid/allocated bytes after data.

May be smaller than "lineStride * height" if this is a section of a larger image.

## ◆ pixelFormat

PixelFormat Image::BitmapData::pixelFormat

The format of the data.

## ◆ lineStride

int Image::BitmapData::lineStride

The number of bytes between each line.

## ◆ pixelStride

int Image::BitmapData::pixelStride

The number of bytes between each pixel.

## ◆ width

int Image::BitmapData::width

## ◆ height

int Image::BitmapData::height

## ◆ dataReleaser

std::unique_ptr<BitmapDataReleaser> Image::BitmapData::dataReleaser

The documentation for this class was generated from the following file:

- juce_Image.h